/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */

import type { FileMetadata } from "./FileMetadata";
import type { FilePathDefinition } from "./FilePathDefinition";
import type { FileTagName } from "./FileTagName";
import type { HttpUrlToUpload } from "./HttpUrlToUpload";
import type { MimeType } from "./MimeType";
import type { OriginalFileName } from "./OriginalFileName";

/**
 * Request body for UploadFromUrl.
 */
export type UploadFromUrlRequest = {
  /**
   * An arbitrary JSON object to store against the file as metadata.
   *
   * You can retrieve this later via a GetFileDetails request.
   */
  metadata?: FileMetadata;
  /**
   * The file's MIME type.
   *
   * If unset, the MIME type of the `url` will be used.
   */
  mime?: MimeType;
  /**
   * The file's original name on the user's device.
   *
   * If unset, the content disposition of the `url` will be used, if any.
   */
  originalFileName?: OriginalFileName;
  /**
   * The path to upload the file to.
   */
  path?: FilePathDefinition;
  /**
   * The file tags to store against the file.
   *
   * When you associate file tags with a file, Upload checks which rules match the tags (if any) and applies those rules to the upload request:
   *
   * Rules can include max file size checks, traffic limit checks, rate limit checks, and so forth. These are configured in the Upload Dashboard.
   */
  tags?: Array<FileTagName>;
  url: HttpUrlToUpload;
};
